
#ifndef PRISM_H
#define PRISM_H
 
#include <iostream>
#include <giac/giac.h>

#include <string>
#include <map>
#include <algorithm>
#include <set>

using namespace std;
using namespace giac;

#include "WVector.h"
#include "Util.h"

extern context ct;

class Prism
{

  friend ostream & operator<<(ostream & out, const Prism &A);
 
 public:
  
  Prism();

  WVector mirror, apex;
  gen apexProjection;
  gen cspine;
  vector<WVector> sides;

  bool invertpairing;

  // next few fields will be used for vertices
  vector<WVector> bottomface;
  vector<WVector> topface;
  vector<WVector> midvertices;
  vector<int> midvertindices;
  vector<unsigned> freeRidges;
  bool isSurrounded;
  int jstart;

  gen pairing;

  gen X0, X1; // Vectors defining bisector as equidistant locus
  //   not sure whether I want these to be negative vectors

  void fillRidge(unsigned k);

  void print();

  Prism mycopy();

};

#endif
